
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Outlet_revenuesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const outlet_revenues = await db.outlet_revenues.create(
            {
                id: data.id || undefined,
        
        revenue_date: data.revenue_date
        ||
        null
            ,
            
        gross_revenue: data.gross_revenue
        ||
        null
            ,
            
        net_revenue: data.net_revenue
        ||
        null
            ,
            
        notes: data.notes
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await outlet_revenues.setOutlet( data.outlet || null, {
            transaction,
        });
        
        await outlet_revenues.setInput_by_user( data.input_by_user || null, {
            transaction,
        });
        
        await outlet_revenues.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return outlet_revenues;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const outlet_revenuesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                revenue_date: item.revenue_date
            ||
            null
            ,
            
                gross_revenue: item.gross_revenue
            ||
            null
            ,
            
                net_revenue: item.net_revenue
            ||
            null
            ,
            
                notes: item.notes
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const outlet_revenues = await db.outlet_revenues.bulkCreate(outlet_revenuesData, { transaction });

        // For each item created, replace relation files
        

        return outlet_revenues;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const outlet_revenues = await db.outlet_revenues.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.revenue_date !== undefined) updatePayload.revenue_date = data.revenue_date;
        
        
        if (data.gross_revenue !== undefined) updatePayload.gross_revenue = data.gross_revenue;
        
        
        if (data.net_revenue !== undefined) updatePayload.net_revenue = data.net_revenue;
        
        
        if (data.notes !== undefined) updatePayload.notes = data.notes;
        
        
        updatePayload.updatedById = currentUser.id;

        await outlet_revenues.update(updatePayload, {transaction});

        
        
        if (data.outlet !== undefined) {
            await outlet_revenues.setOutlet(
              
              data.outlet,
              
              { transaction }
            );
        }
        
        if (data.input_by_user !== undefined) {
            await outlet_revenues.setInput_by_user(
              
              data.input_by_user,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await outlet_revenues.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return outlet_revenues;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const outlet_revenues = await db.outlet_revenues.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of outlet_revenues) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of outlet_revenues) {
                await record.destroy({transaction});
            }
        });


        return outlet_revenues;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const outlet_revenues = await db.outlet_revenues.findByPk(id, options);

        await outlet_revenues.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await outlet_revenues.destroy({
            transaction
        });

        return outlet_revenues;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const outlet_revenues = await db.outlet_revenues.findOne(
            { where },
            { transaction },
        );

        if (!outlet_revenues) {
            return outlet_revenues;
        }

        const output = outlet_revenues.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.outlet = await outlet_revenues.getOutlet({
            transaction
        });
        
        
        output.input_by_user = await outlet_revenues.getInput_by_user({
            transaction
        });
        
        
        output.organizations = await outlet_revenues.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.outlets,
        as: 'outlet',
        
        where: filter.outlet ? {
          [Op.or]: [
            { id: { [Op.in]: filter.outlet.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.outlet.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'input_by_user',
        
        where: filter.input_by_user ? {
          [Op.or]: [
            { id: { [Op.in]: filter.input_by_user.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.input_by_user.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.notes) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'outlet_revenues',
                        'notes',
                        filter.notes,
                    ),
                };
            }
            

            
            
            if (filter.calendarStart && filter.calendarEnd) {
                where = {
                    ...where,
                    [Op.or]: [
                        {
                            revenue_date: {
                                [Op.between]: [filter.calendarStart, filter.calendarEnd],
                            },
                    },
                {
                    revenue_date: {
                        [Op.between]: [filter.calendarStart, filter.calendarEnd],
                    },
                },
                ],
            };
            }
            

            
            if (filter.revenue_dateRange) {
                const [start, end] = filter.revenue_dateRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    revenue_date: {
                    ...where.revenue_date,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    revenue_date: {
                    ...where.revenue_date,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.gross_revenueRange) {
                const [start, end] = filter.gross_revenueRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    gross_revenue: {
                    ...where.gross_revenue,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    gross_revenue: {
                    ...where.gross_revenue,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.net_revenueRange) {
                const [start, end] = filter.net_revenueRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    net_revenue: {
                    ...where.net_revenue,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    net_revenue: {
                    ...where.net_revenue,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            


      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.outlet_revenues.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'outlet_revenues',
                        'notes',
                        query,
                    ),
                ],
            };
        }

        const records = await db.outlet_revenues.findAll({
            attributes: [ 'id', 'notes' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['notes', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.notes,
        }));
    }

    
};

